unit frmmain; 

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs, Menus,
  fpCanvas,fpImage;

type

  { TMainForm }

  TMainForm = class(TForm)
    MainMenu1: TMainMenu;
    MenuItem1: TMenuItem;
    MIQuit: TMenuItem;
    MIBitmap: TMenuItem;
    MISavePostScript: TMenuItem;
    MIdraw: TMenuItem;
    MFile: TMenuItem;
    SDDraw: TSaveDialog;
    procedure MIBitmapClick(Sender: TObject);
    procedure MIQuitClick(Sender: TObject);
    procedure MISavePostScriptClick(Sender: TObject);
    procedure MIdrawClick(Sender: TObject);
    procedure MainFormPaint(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
    Procedure DoDraw(ACanvas : TFPCustomCanvas);
  end;

var
  MainForm: TMainForm;

implementation

uses pscanvas,fpimgcanv,fpWriteJpeg;

{ TMainForm }

procedure TMainForm.MIdrawClick(Sender: TObject);
begin
  DoDraw(Canvas);
end;

procedure TMainForm.MainFormPaint(Sender: TObject);
begin
  DoDraw(Canvas);
end;

procedure TMainForm.MISavePostScriptClick(Sender: TObject);

Var
  F : TFileStream;
  PSCanvas : TPostScriptCanvas;

begin
  With SDDraw do
    begin
    Filter:='Postscript files|*.ps|All Files|*.*';
    If Execute then
      begin
      F:=TFileStream.Create(FileName,fmCreate);
      Try
        PSCanvas:= TPostScriptCanvas.Create(F);
        Try
          DoDraw(PSCanvas);
        Finally
          PSCanvas.Free;
        end;
      Finally
        F.Free;
      end;
      end;
    end;
end;

procedure TMainForm.MIQuitClick(Sender: TObject);
begin
  Close;
end;

procedure TMainForm.MIBitmapClick(Sender: TObject);

Var
  Image : TFPMemoryImage;
  ICanvas : TFPImageCanvas;
  W : TFPWriterJPEG;
  Fn  : String;
  
begin
  With SDDraw do
    begin
    Filter:='JPEG files|*.jpg|All Files|*.*';
    If Execute then
      FN:=FileName;
    end;
  If FN='' then
    exit;
  image := TFPMemoryImage.Create (110,110);
  Try
    ICanvas:=TFPImageCanvas.Create (image);
    Try
      DoDraw(ICanvas);
    Finally
      ICanvas.Free;
    end;
//    Image.SaveToFile(FN);
  Finally
    Image.Free;
  end;
end;

procedure TMainForm.DoDraw(ACanvas : TFPCustomCanvas);

Var
  I : Integer;
  R : TRect;
  APolyGon : Array [0..8] of TPoint;
  
begin
  R.Top:=10;
  R.Left:=10;
  R.Right:=100;
  R.Bottom:=100;
  ACanvas.Pen.FPColor:=colRed;
  ACanvas.Rectangle(R);
  ACanvas.Ellipse(R);
  ACanvas.Pen.FPColor:=colGreen;
  ACanvas.Line(10,10,100,100);
  ACanvas.Line(10,100,100,10);
  ACanvas.Pen.FPColor:=colBlue;
  ACanvas.MoveTo(10,55);
  ACanvas.LineTo(100,55);
  ACanvas.MoveTo(55,10);
  ACanvas.LineTo(55,100);
  ACanvas.Pen.FPColor:=colYellow;
  For I:=0 to 8 do
    with APolyGon[i] do
      begin
      X:=55+Trunc(Cos(I*pi/4)*45);
      Y:=55+Trunc(Sin(I*pi/4)*45);
      end;
  ACanvas.PolyLine(APolyGon);
//  ACanvas.Polygon(APolyGon);
end;

initialization
  {$I frmmain.lrs}

end.

